Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/jobs/details/jobTaskDetailsDialog.cshtml
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/jobs/details/jobTaskDetailsDialog.cshtml	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/jobs/details/jobTaskDetailsDialog.cshtml	(revision 12551)
@@ -12,9 +12,11 @@
                             <tr>
                                 <td>Start Time:</td>
-                                <td class="text-right">{{task.StartTime}}</td>
+                                <td ng-show="task.StartTime" class="text-left">{{task.StartTime | toDate}}</td>
+                                <td ng-hide="task.StartTime" class="text-left">Not started</td>
                             </tr>
                             <tr>
                                 <td>End Time:</td>
-                                <td class="text-right">{{task.EndTime}}</td>
+                                <td ng-show="task.EndTime" class="text-left">{{task.EndTime | toDate}}</td>
+                                <td ng-hide="task.EndTime" class="text-left">Not finished</td>
                             </tr>
                             <tr>
@@ -37,21 +39,21 @@
                             <tr>
                                 <td>Total Time:</td>
-                                <td>{{task.TotalTime}}</td>
+                                <td>{{task.TotalTime | toTimespan}}</td>
                             </tr>
                             <tr>
                                 <td>Initial Waiting Time:</td>
-                                <td>{{task.InitialWaitingTime}}</td>
+                                <td>{{task.InitialWaitingTime | toTimespan}}</td>
                             </tr>
                             <tr>
                                 <td>Waiting Time:</td>
-                                <td>{{task.WaitingTime}}</td>
+                                <td>{{task.WaitingTime | toTimespan}}</td>
                             </tr>
                             <tr>
                                 <td>Calculating Time:</td>
-                                <td>{{task.CalculatingTime}}</td>
+                                <td>{{task.CalculatingTime | toTimespan}}</td>
                             </tr>
                             <tr>
                                 <td>Transfer Time:</td>
-                                <td>{{task.TransferTime}}</td>
+                                <td>{{task.TransferTime | toTimespan}}</td>
                             </tr>
                         </table>
@@ -61,21 +63,21 @@
                             <tr>
                                 <td>Calculation Runs:</td>
-                                <td>{{task.NumCalculationRuns}}</td>
+                                <td class="text-right">{{task.NumCalculationRuns}}</td>
                             </tr>
                             <tr>
                                 <td>Retries Runs:</td>
-                                <td>{{task.NumRetries}}</td>
+                                <td class="text-right">{{task.NumRetries}}</td>
                             </tr>
                             <tr>
                                 <td>Cores Required:</td>
-                                <td>{{task.CoresRequired}}</td>
+                                <td class="text-right">{{task.CoresRequired}}</td>
                             </tr>
                             <tr>
                                 <td>Memory Required:</td>
-                                <td>{{task.MemoryRequired}}</td>
+                                <td class="text-right">{{task.MemoryRequired}} MB</td>
                             </tr>
                             <tr>
                                 <td>Priority:</td>
-                                <td>{{task.Priority}}</td>
+                                <td class="text-right">{{task.Priority}}</td>
                             </tr>
                         </table>
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/jobs/jobs.cshtml
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/jobs/jobs.cshtml	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/jobs/jobs.cshtml	(revision 12551)
@@ -17,4 +17,9 @@
             <a ng-href="#/statistics/groups">Groups</a>
         </li>
+        @if (Request.IsAuthenticated && User.IsInRole(HiveRoles.Administrator)) {
+            <li>
+                <a ng-href="#/statistics/exceptions">Exceptions</a>
+            </li>
+        }
     </ul>
 </header>
@@ -33,4 +38,7 @@
                             <th>#</th>
                             <th>Job Name</th>
+                            @if (Request.IsAuthenticated && User.IsInRole(HiveRoles.Administrator)) {
+                                <th>User Name</th>
+                            }
                             <th>Date Created</th>
                             <th>Progress</th>
@@ -38,42 +46,5 @@
                         </tr>
                         </thead>
-                        <tr ng-repeat="job in jobs">
-                            <td>{{$index + 1}}</td>
-                            <td>{{job.Name}}</td>
-                            <td>{{job.DateCreated}}</td>
-                            <td>
-                                <progressbar class="progress active" max="job.TotalTasks" value="job.CompletedTasks" type="success"><i style="color:black; white-space:nowrap;">{{job.CompletedTasks}} / {{job.TotalTasks}}</i></progressbar>
-                            </td>
-                            <td>
-                                <a ng-href="#/statistics/jobs/{{job.Id}}">Details</a>
-                            </td>
-                        </tr>
-                        <tr ng-hide="jobs.length">
-                            <td colspan="5" class="text-center">No active jobs found!</td>
-                        </tr>
-                    </table>
-                </div>
-            </div>
-        </div>
-    </div>
-    @if (Request.IsAuthenticated && User.IsInRole(HiveRoles.Administrator)) {
-        <div class="row">
-            <div class="col-lg-12">
-                <div class="panel panel-default">
-                    <div class="panel-heading">
-                        <h3 class="panel-title">Current Active Jobs</h3>
-                    </div>
-                    <div class="panel-body">
-                        <table class="table table-hover table-condensed">
-                            <thead>
-                                <tr>
-                                    <th>#</th>
-                                    <th>Job Name</th>
-                                    <th>User Name</th>
-                                    <th>Date Created</th>
-                                    <th>Progress</th>
-                                    <th></th>
-                                </tr>
-                            </thead>
+                        @if (Request.IsAuthenticated && User.IsInRole(HiveRoles.Administrator)) {
                             <tr ng-repeat="job in allUsersJobs">
                                 <td>{{$index + 1}}</td>
@@ -82,5 +53,5 @@
                                     <a ng-href="#/statistics/users/{{job.UserId}}" ng-show="job.UserName">{{job.UserName}}</a>
                                 </td>
-                                <td>{{job.DateCreated}}</td>
+                                <td>{{job.DateCreated | toDate}}</td>
                                 <td>
                                     <progressbar class="progress active" max="job.TotalTasks" value="job.CompletedTasks" type="success"><i style="color:black; white-space:nowrap;">{{job.CompletedTasks}} / {{job.TotalTasks}}</i></progressbar>
@@ -93,10 +64,26 @@
                                 <td colspan="6" class="text-center">No active jobs found!</td>
                             </tr>
-                        </table>
-                    </div>
+                        } else {
+                            <tr ng-repeat="job in jobs">
+                                <td>{{$index + 1}}</td>
+                                <td>{{job.Name}}</td>
+                                <td>{{job.DateCreated | toDate}}</td>
+                                <td>
+                                    <progressbar class="progress active" max="job.TotalTasks" value="job.CompletedTasks" type="success"><i style="color: black; white-space: nowrap;">{{job.CompletedTasks}} / {{job.TotalTasks}}</i></progressbar>
+                                </td>
+                                <td>
+                                    <a ng-href="#/statistics/jobs/{{job.Id}}">Details</a>
+                                </td>
+                            </tr>
+                            <tr ng-hide="jobs.length">
+                                <td colspan="5" class="text-center">No active jobs found!</td>
+                            </tr>
+                        }
+                    </table>
                 </div>
             </div>
         </div>
-    }
+    </div>
+
     <div class="row">
         <div class="col-lg-12">
@@ -120,6 +107,6 @@
                             <td>{{($index + 1)+((completedJobCurPage-1)*(completedJobPageSize))}}</td>
                             <td>{{job.Name}}</td>
-                            <td>{{job.DateCreated}}</td>
-                            <td>{{job.DateCompleted}}</td>
+                            <td>{{job.DateCreated | toDate}}</td>
+                            <td>{{job.DateCompleted | toDate}}</td>
                             <td>{{job.TotalTasks}}</td>
                             <td><a ng-href="#/statistics/jobs/{{job.Id}}">Details</a></td>
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/jobs/jobsCtrl.js
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/jobs/jobsCtrl.js	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/jobs/jobsCtrl.js	(revision 12551)
@@ -12,8 +12,4 @@
                 jobService.getAllJobs({ completed: false }, function(jobs) {
                     $scope.jobs = jobs;
-                    var length = $scope.jobs.length;
-                    for (var i = 0; i < length; ++i) {
-                        $scope.jobs[i].DateCreated = CSharpDateToString($scope.jobs[i].DateCreated);
-                    }
                 });
             };
@@ -23,9 +19,4 @@
                     function (jobPage) {
                         $scope.completedJobPage = jobPage;
-                        var length = $scope.completedJobPage.Jobs.length;
-                        for (var i = 0; i < length; ++i) {
-                            $scope.completedJobPage.Jobs[i].DateCreated = CSharpDateToString($scope.completedJobPage.Jobs[i].DateCreated);
-                            $scope.completedJobPage.Jobs[i].DateCompleted = CSharpDateToString($scope.completedJobPage.Jobs[i].DateCompleted);
-                        }
                     }
                 );
@@ -36,8 +27,4 @@
                     $scope.isAdministrator = true;
                     $scope.allUsersJobs = jobs;
-                    var length = $scope.allUsersJobs.length;
-                    for (var i = 0; i < length; ++i) {
-                        $scope.allUsersJobs[i].DateCreated = CSharpDateToString($scope.allUsersJobs[i].DateCreated);
-                    }
                 });
             };
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/services/clientService.js
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/services/clientService.js	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/services/clientService.js	(revision 12551)
@@ -4,5 +4,5 @@
     module.factory('app.statistics.clientService',
         ['$resource', function ($resource) {
-            return $resource(apiUrl + ':action', { id: '@id', page: '@page', size: '@size', states: '@states', expired: '@expired', start: '@start', end: '@end' }, {
+            return $resource(apiUrl + ':action', { id: '@id', page: '@page', size: '@size', states: '@states', expired: '@expired', start: '@start', end: '@end', userId: '@userId' }, {
                 getClientDetails: { method: 'GET', params: { action: 'GetClientDetails' } },
                 getClients: { method: 'GET', params: { action: 'GetClients' } },
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/users/details/userDetails.cshtml
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/users/details/userDetails.cshtml	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/users/details/userDetails.cshtml	(revision 12551)
@@ -16,4 +16,9 @@
             <a ng-href="#/statistics/groups">Groups</a>
         </li>
+        @if (Request.IsAuthenticated && User.IsInRole(HiveRoles.Administrator)) {
+            <li>
+                <a ng-href="#/statistics/exceptions">Exceptions</a>
+            </li>
+        }
     </ul>
 </header>
@@ -46,7 +51,7 @@
                         <tr>
                             <td class="text-left">Total:</td>
-                            <td class="text-right">{{totalJobTasks}}</td>
+                            <td class="text-right">{{totalUserTasks}}</td>
                         </tr>
-                        <tr ng-repeat="state in states">
+                        <tr ng-repeat="state in user.TasksStates">
                             <td class="text-left">{{state.State}}:</td>
                             <td class="text-right">{{state.Count}}</td>
@@ -78,5 +83,5 @@
                             <td>{{$index + 1}}</td>
                             <td>{{job.Name}}</td>
-                            <td>{{job.DateCreated}}</td>
+                            <td>{{job.DateCreated | toDate}}</td>
                             <td>
                                 <progressbar class="progress active" max="job.TotalTasks" value="job.CompletedTasks" type="success"><i style="color:black; white-space:nowrap;">{{job.CompletedTasks}} / {{job.TotalTasks}}</i></progressbar>
@@ -116,6 +121,6 @@
                             <td>{{($index + 1)+((completedJobCurPage-1)*(completedJobPageSize))}}</td>
                             <td>{{job.Name}}</td>
-                            <td>{{job.DateCreated}}</td>
-                            <td>{{job.DateCompleted}}</td>
+                            <td>{{job.DateCreated | toDate}}</td>
+                            <td>{{job.DateCompleted | toDate}}</td>
                             <td>{{job.TotalTasks}}</td>
                             <td><a ng-href="#/statistics/jobs/{{job.Id}}">Details</a></td>
@@ -135,5 +140,4 @@
         </div>
     </div>
-
 </div>
 }
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/users/details/userDetailsCtrl.js
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/users/details/userDetailsCtrl.js	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/users/details/userDetailsCtrl.js	(revision 12551)
@@ -12,4 +12,11 @@
                 userService.getUser({ id: $stateParams.id }, function(user) {
                     $scope.user = user;
+
+                    var length = user.TasksStates.length;
+                    var total = 0;
+                    for (var i = 0; i < length; ++i) {
+                        total += user.TasksStates[i].Count;
+                    }
+                    $scope.totalUserTasks = total;
                 });
             };
@@ -18,8 +25,4 @@
                 jobService.getAllJobsByUserId({ id: $stateParams.id, completed: false }, function (jobs) {
                     $scope.jobs = jobs;
-                    var length = $scope.jobs.length;
-                    for (var i = 0; i < length; ++i) {
-                        $scope.jobs[i].DateCreated = CSharpDateToString($scope.jobs[i].DateCreated);
-                    }
                 });
             };
@@ -29,9 +32,4 @@
                     function (jobPage) {
                         $scope.completedJobPage = jobPage;
-                        var length = $scope.completedJobPage.Jobs.length;
-                        for (var i = 0; i < length; ++i) {
-                            $scope.completedJobPage.Jobs[i].DateCreated = CSharpDateToString($scope.completedJobPage.Jobs[i].DateCreated);
-                            $scope.completedJobPage.Jobs[i].DateCompleted = CSharpDateToString($scope.completedJobPage.Jobs[i].DateCompleted);
-                        }
                     }
                 );
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/users/users.cshtml
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/users/users.cshtml	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/users/users.cshtml	(revision 12551)
@@ -16,4 +16,9 @@
             <a ng-href="#/statistics/groups">Groups</a>
         </li>
+        @if (Request.IsAuthenticated && User.IsInRole(HiveRoles.Administrator)) {
+            <li>
+                <a ng-href="#/statistics/exceptions">Exceptions</a>
+            </li>
+        }
     </ul>
 </header>
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/statistics.js
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/statistics.js	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/statistics.js	(revision 12551)
@@ -6,9 +6,10 @@
         'WebApp/statistics.css',
         'WebApp/services/statisticsService.js',
+        'WebApp/services/clientService.js',
+        'WebApp/services/exceptionService.js',
+        'WebApp/services/groupService.js',
         'WebApp/services/jobService.js',
         'WebApp/services/taskService.js',
         'WebApp/services/userService.js',
-        'WebApp/services/clientService.js',
-        'WebApp/services/groupService.js',
         'WebApp/jobs/jobsCtrl.js',
         'WebApp/jobs/details/jobDetailsCtrl.js',
@@ -20,5 +21,7 @@
         'WebApp/users/details/userDetailsCtrl.js',
         'WebApp/groups/groupsCtrl.js',
-        'WebApp/groups/details/groupDetailsCtrl.js'
+        'WebApp/groups/details/groupDetailsCtrl.js',
+        'WebApp/exceptions/exceptionsCtrl.js',
+        'WebApp/exceptions/exceptionDetailsDialogCtrl.js'
     ];
     plugin.view = 'WebApp/jobs/jobs.cshtml';
@@ -32,5 +35,6 @@
         new Route('users/:id', 'WebApp/users/details/userDetails.cshtml', 'app.statistics.userDetailsCtrl'),
         new Route('groups', 'WebApp/groups/groups.cshtml', 'app.statistics.groupsCtrl'),
-        new Route('groups/:id', 'WebApp/groups/details/groupDetails.cshtml', 'app.statistics.groupDetailsCtrl')
+        new Route('groups/:id', 'WebApp/groups/details/groupDetails.cshtml', 'app.statistics.groupDetailsCtrl'),
+        new Route('exceptions', 'WebApp/exceptions/exceptions.cshtml', 'app.statistics.exceptionsCtrl')
     ];
     var menu = app.getMenu();
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Status/3.3/HeuristicLab.Services.WebApp.Status-3.3.csproj
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Status/3.3/HeuristicLab.Services.WebApp.Status-3.3.csproj	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Status/3.3/HeuristicLab.Services.WebApp.Status-3.3.csproj	(revision 12551)
@@ -73,7 +73,7 @@
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="Newtonsoft.Json, Version=6.0.0.0, Culture=neutral, PublicKeyToken=30ad4fe6b2a6aeed, processorArchitecture=MSIL">
-      <HintPath>..\..\packages\Newtonsoft.Json.6.0.4\lib\net45\Newtonsoft.Json.dll</HintPath>
-      <Private>False</Private>
+    <Reference Include="Newtonsoft.Json, Version=7.0.0.0, Culture=neutral, PublicKeyToken=30ad4fe6b2a6aeed, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\packages\Newtonsoft.Json.7.0.1\lib\net45\Newtonsoft.Json.dll</HintPath>
     </Reference>
     <Reference Include="System" />
